/*
 * RiskAversionAgent.java
 *
 * Created on 16. bezen 2007, 20:22
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package riskaversion;

/**
 *
 * @author tygracek
 */
public class RiskAversionAgent {
    
    public double rAversion;
    public int age;
    public int winner; //0 - didnt played, 1 - winner, 2 - looser
                       // used only in unbound evolution and non fatal failures 
    RiskAversionModel model;
            
   
    public boolean checkAge(int maxAge) {
        
      age ++;
      if (age>maxAge) {
        model.removeAgent(this);
        return (false);
      }
      else
        return (true);
    }
   
    public void reproduction(double mutationRange) {
      
      double newAversion;
      
      if (model.sexualReproduction) {
      double mateAversion = model.getAgent
               (model.getNextIntFromTo(0,model.getAgentNumber()-1)).rAversion;
       newAversion = ((rAversion + mateAversion)/2) +
              model.getNextDoubleFromTo(-mutationRange,mutationRange);
      }
       else
         newAversion = rAversion +
              model.getNextDoubleFromTo(-mutationRange,mutationRange);
      
      if (newAversion<0) newAversion = 0;
      else if (newAversion>1) newAversion = 1;
      
      model.addAgent(new RiskAversionAgent(newAversion,0,model) );      
    }
    
    
    /**
     * Creates a new instance of RiskAversionAgent
     */
    public RiskAversionAgent(double aversion, int a, RiskAversionModel m) {
        rAversion = aversion;
        age = a;
        model = m;
        winner = 0;
    }
    
  public void play(double deathProb) { 
    winner=0;
    if (model.getNextDoubleFromTo(0d,1d) > rAversion) {
      if (model.getNextDoubleFromTo(0d,1d) < deathProb) {
        //unremark next line for fatal loosers  
         model.removeAgent(this);
        
        //unremark next line for non fatal loosers
        //winner=2;
      }
      else {
        winner=1;
        model.addWinner(this);
      }
    }
    
   // System.out.println("Aversion:"+rAversion+" Age:"+age+" Winner:"+winner);
  }  
}
